/// This file has been generated, if you wish to
/// modify it in a permanent way, please refer
/// to the script file : gen/generator_cxx.rb

#include "prologin.hh"
#include <bits/stdc++.h>

using namespace std;

int id_joueur, id_adv, nb_aliens, attaque;
int dx[] = {1,0,0,-1};
int dy[] = {0,1,-1,0};
vector<alien_info> aliens;
case_type carte[TAILLE_BANQUISE][TAILLE_BANQUISE];
map<position, vector<pair<int, position>>> graphe;
position agent[NB_AGENTS], agent_adv[NB_AGENTS];
map<position, int> dist;
map<position, position> prec;

bool cmp_alien(pair<alien_info, int> a, pair<alien_info, int> b) {
    return a.second < b.second;
}

void dd(position s) {
    position pos;
    for (int i = 0; i < TAILLE_BANQUISE; i++) {
        pos.ligne = i;
        for (int j = 0; j < TAILLE_BANQUISE; j++) {
            pos.colonne = j;
            dist[pos] = 1000;
        }
    }
    priority_queue<pair<int, pair<position,position>>> q;
    q.push(make_pair(0,make_pair(s,s)));
    while (!q.empty()) {
        pair<int, pair<position,position>> t = q.top();
        q.pop();
        ///cout << s.ligne << " " << s.colonne << ":" << endl;
        ///cout << dist[t.second.second] << " " << t.first << endl;
        if (dist[t.second.second] > -t.first) {
            dist[t.second.second] = -t.first;
            prec[t.second.second] = t.second.first;
            ///cout << "OK " << t.second.second.ligne << " " << t.second.second.colonne << " < " << t.second.first.ligne << " " << t.second.first.colonne << endl;
            for (int i = 0; i < (int) graphe[t.second.second].size(); i++) {
                q.push(make_pair(-dist[t.second.second] - graphe[t.second.second][i].first, make_pair(t.second.second, graphe[t.second.second][i].second)));
            }
        }
    }
}

/// Fonction appelée au début de la partie.
void partie_init()
{
    id_joueur = moi();
    id_adv = adversaire();
    position pos;
    for (int i = 0; i < TAILLE_BANQUISE; i++) {
        pos.ligne = i;
        for (int j = 0; j < TAILLE_BANQUISE; j++) {
            pos.colonne = j;
            carte[i][j] = type_case(pos);
        }
    }
}

/// Fonction appelée à chaque tour.
void jouer_tour()
{
    int tour = tour_actuel();
    position pos,pos2;
    for (int i = 0; i < TAILLE_BANQUISE; i++) {
        pos.ligne = i;
        for (int j = 0; j < TAILLE_BANQUISE; j++) {
            pos.colonne = j;
            graphe[pos].clear();
        }
    }
    for (int i = 0; i < NB_AGENTS; i++) {
        agent[i] = position_agent(id_joueur, i);
        agent_adv[i] = position_agent(id_adv, i);
        carte[agent_adv[i].ligne][agent_adv[i].colonne] = MUR;
    }
    for (int i = 0; i < TAILLE_BANQUISE; i++) {
        pos2.ligne = i;
        for (int j = 0; j < TAILLE_BANQUISE; j++) {
            pos2.colonne = j;
            for (int k = 0; k < 4; k++) {
                pos.ligne = i + dx[k];
                pos.colonne = j + dy[k];
                if (i+dx[k] < 0 || i+dx[k] > 24 || j+dy[k] < 0 || j+dy[k] > 24) { continue; }
                if (carte[i][j] == LIBRE && carte[pos.ligne][pos.colonne] == LIBRE) { graphe[pos2].push_back(make_pair(1, pos)); }
            }
        }
    }
    for (int i = 0; i < TAILLE_BANQUISE; i++) {
        int j = 0;
        pos.ligne = i;
        pos2.ligne = i;
        while (j < 25) {
            while (j < 25 && carte[i][j] == MUR) { j++; }
            pos.colonne = j;
            if (j == 25) { break; }
            while (j < 25 && carte[i][j] == LIBRE) {
                pos2.colonne = j;
                if (j-pos.colonne >= 3) {
                    graphe[pos2].push_back(make_pair(3, pos));
                }
                j++;
            }
            j--;
            pos2.colonne = j;
            if (j-pos.colonne >= 3) {
                graphe[pos].push_back(make_pair(3, pos2));
            }
            j++;
        }
    }
    for (int i = 0; i < TAILLE_BANQUISE; i++) {
        int j = 0;
        pos.colonne = i;
        pos2.colonne = i;
        while (j < 25) {
            while (j < 25 && carte[j][i] == MUR) { j++; }
            pos.ligne = j;
            if (j == 25) { break; }
            while (j < 25 && carte[j][i] == LIBRE) {
                pos2.ligne = j;
                if (j-pos.ligne >= 3) {
                    graphe[pos2].push_back(make_pair(3, pos));
                }
                j++;
            }
            j--;
            if (j-pos.ligne >= 3) {
                graphe[pos].push_back(make_pair(3, pos2));
            }
            j++;
        }
    }
    aliens = liste_aliens();
    nb_aliens = (int) aliens.size();
    vector<int> dist_agents[4];
    vector<int> occupe_aliens[4];
    for (int k = 0; k < 4; k++) {
        dd(agent[k]);
        for (int i = 0; i < nb_aliens; i++) {
            if (aliens[i].points_capture > 0 && tour+min(2, dist[aliens[i].pos]) >= aliens[i].tour_invasion && tour+3-aliens[i].capture_en_cours <= (aliens[i].tour_invasion + aliens[i].duree_invasion) && aliens[i].capture_en_cours < NB_TOURS_CAPTURE) {
                dist_agents[k].push_back(dist[aliens[i].pos]);
                if (agent[k] == aliens[i].pos) { dist_agents[k][i] = -1000; }
                occupe_aliens[k].push_back(0);
                /*if (agent_sur_case(aliens[i].pos) != id_adv && tour+dist[aliens[i].pos]+3-aliens[i].capture_en_cours > (aliens[i].tour_invasion + aliens[i].duree_invasion)) {
                    dist_agents[k][i] = 1000;
                }
                else */if (dist[aliens[i].pos] == 1000) {
                    for (int l = 0; l < 4; l++) {
                        pos.ligne = aliens[i].pos.ligne + dx[l];
                        pos.colonne = aliens[i].pos.colonne + dy[l];
                        if (pos.ligne < 0 || pos.ligne > 24 || pos.colonne < 0 || pos.colonne > 24) { continue; }
                        if (dist[pos] < dist_agents[k][i] && carte[pos.ligne - 2*dx[l]][pos.colonne - 2*dy[l]] == LIBRE) {
                            occupe_aliens[k][i] = l+1;
                            dist_agents[k][i] = dist[pos];
                        }
                    }
                }
            }
            else { dist_agents[k].push_back(1000); occupe_aliens[k].push_back(0); }
        }
    }
    int mk1, mk2, mk3, mk4, garde = -1, special = -1;
    int min_dist = 9001;
    for (int k1 = 0; k1 < nb_aliens; k1++) {
        for (int k2 = 0; k2 < nb_aliens; k2++) {
            if (k1 == k2) { continue; }
            for (int k3 = 0; k3 < nb_aliens; k3++) {
                if (k3 == k2) { continue; }
                if (k1 == k3) { continue; }
                for (int k4 = 0; k4 < nb_aliens; k4++) {
                    if (k4 == k1) { continue; }
                    if (k4 == k2) { continue; }
                    if (k4 == k3) { continue; }
                    int sm = dist_agents[0][k1]+dist_agents[1][k2]+dist_agents[2][k3]+dist_agents[3][k4];
                    if (sm < min_dist) {
                        min_dist = sm;
                        mk1 = k1; mk2 = k2; mk3 = k3; mk4 = k4;
                    }
                }
            }
        }
    }
    int mn = 1000, in = -1, mkn = -1;
    int mx = -1, ix = -1, mkx = -1;
    if (dist_agents[0][mk1] != 1000) {
        if (dist_agents[0][mk1] < mn) { mn = dist_agents[0][mk1]; in = 0; mkn = mk1; }
        if (dist_agents[0][mk1] > mx) { mx = dist_agents[0][mk1]; ix = 0; mkx = mk1; }
    }
    if (dist_agents[1][mk2] != 1000) {
        if (dist_agents[1][mk2] < mn) { mn = dist_agents[1][mk2]; in = 1; mkn = mk2; }
        if (dist_agents[1][mk2] > mx) { mx = dist_agents[1][mk2]; ix = 1; mkx = mk2; }
    }
    if (dist_agents[2][mk3] != 1000) {
        if (dist_agents[2][mk3] < mn) { mn = dist_agents[2][mk3]; in = 2; mkn = mk3; }
        if (dist_agents[2][mk3] > mx) { mx = dist_agents[2][mk3]; ix = 2; mkx = mk3; }
    }
    if (dist_agents[3][mk4] != 1000) {
        if (dist_agents[3][mk4] < mn) { mn = dist_agents[3][mk4]; in = 3; mkn = mk4; }
        if (dist_agents[3][mk4] > mx) { mx = dist_agents[3][mk4]; ix = 3; mkx = mk4; }
    }
    if (mx > 2.5*mn && dist_agents[in][mkx] < 1000 && dist_agents[in][mkn] > 0) { garde = in; special = ix; }
    ///int libre[4] = {0};
    ///vector<position> collegues, postes;
    for (int k = 0; k < 4; k++) {
        if (garde == k) { continue; }
        int dst, occupe, mk;
        vector<position> prec1;
        if (k == 0) { mk = mk1; }
        else if (k == 1) { mk = mk2; }
        else if (k == 2) { mk = mk3; }
        else { mk = mk4; }
        pos = aliens[mk].pos;
        dst = dist_agents[k][mk];
        occupe = occupe_aliens[k][mk];
        if (dst == 0 && occupe > 0) {
            if (occupe == 1) {
                pousser(k, NORD);
                deplacer(k, NORD);
            }
            else if (occupe == 2) {
                pousser(k, OUEST);
                deplacer(k, OUEST);
            }
            else if (occupe == 3) {
                pousser(k, EST);
                deplacer(k, EST);
            }
            else {
                pousser(k, SUD);
                deplacer(k, SUD);
            }
        }
        else if (dst < 1000) {
            if (occupe > 0) {
                pos.ligne += dx[occupe-1];
                pos.colonne += dy[occupe-1];
            }
            dd(agent[k]);
            ///cout << id_joueur << " " << k << " " << occupe << " " << mk << endl;
            ///cout << agent[k].ligne << " " << agent[k].colonne << endl;
            ///cout << pos.ligne << " " << pos.colonne << endl;
            ///cout << dist[pos] << endl;
            while (pos != agent[k]) {
                prec1.push_back(pos);
                pos = prec[pos];
            }
            int points = 8, lg = (int) prec1.size() - 1;
            while (points > 0 && lg >= 0) {
                position nv = prec1[lg];
                if (pos.ligne == nv.ligne && pos.colonne > nv.colonne) { /// OUEST
                    if (pos.colonne == nv.colonne + 1) { deplacer(k, OUEST); points--; }
                    else if (points >= 3) { glisser(k, OUEST); points -= 3; }
                    else { points = 0; }
                }
                else if (pos.ligne == nv.ligne && pos.colonne < nv.colonne) { /// EST
                    if (pos.colonne == nv.colonne - 1) { deplacer(k, EST); points--; }
                    else if (points >= 3) { glisser(k, EST); points -= 3; }
                    else { points = 0; }
                }
                else if (pos.ligne > nv.ligne && pos.colonne == nv.colonne) { /// NORD
                    if (pos.ligne == nv.ligne + 1) { deplacer(k, NORD); points--; }
                    else if (points >= 3) { glisser(k, NORD); points -= 3; }
                    else { points = 0; }
                }
                else { /// SUD
                    if (pos.ligne == nv.ligne - 1) { deplacer(k, SUD); points--; }
                    else if (points >= 3) { glisser(k, SUD); points -= 3; }
                    else { points = 0; }
                }
                pos = nv;
                lg--;
            }
            if (points >= 5 && occupe > 0) {
                ///cout << id_joueur << " " << occupe << endl;
                if (occupe == 1) {
                    pousser(k, NORD);
                    deplacer(k, NORD);
                }
                else if (occupe == 2) {
                    pousser(k, OUEST);
                    deplacer(k, OUEST);
                }
                else if (occupe == 3) {
                    pousser(k, EST);
                    deplacer(k, EST);
                }
                else {
                    pousser(k, SUD);
                    deplacer(k, SUD);
                }
            }
            if (points >= 5) {
                for (int l = 0; l < 4; l++) {
                    pos2.ligne = pos.ligne + dx[l];
                    pos2.colonne = pos.colonne + dy[l];
                    if (pos.ligne < 0 || pos.ligne > 24 || pos.colonne < 0 || pos.colonne > 24) { continue; }
                    if (agent_sur_case(pos2) == id_adv) {
                        if (l == 0) { pousser(k, NORD); }
                        else if (l == 1) { pousser(k, OUEST); }
                        else if (l == 2) { pousser(k, EST); }
                        else { pousser(k, SUD); }
                        points -= 5;
                        break;
                    }
                }
            }
        } ///else { cout << id_joueur << " ... " << k << endl; }
    }
    if (garde >= 0) {
        int mk;
        if (special == 0) { mk = mk1; }
        else if (special == 1) { mk = mk2; }
        else if (special == 2) { mk = mk3; }
        else { mk = mk4; }
        pos = aliens[mk].pos;
        int occupe_garde = -1, dist_garde = 1000;
        if (agent_sur_case(pos) == id_adv) {
            cout << "adv" << endl;
            dd(agent[garde]);
            for (int l = 0; l < 4; l++) {
                pos.ligne = aliens[mk].pos.ligne + dx[l];
                pos.colonne = aliens[mk].pos.colonne + dy[l];
                if (pos.ligne < 0 || pos.ligne > 24 || pos.colonne < 0 || pos.colonne > 24) { continue; }
                if (dist[pos] < dist_garde && carte[pos.ligne - 2*dx[l]][pos.colonne - 2*dy[l]] == LIBRE) {
                    occupe_garde = l+1;
                    dist_garde = dist[pos];
                }
            }
            if (occupe_garde == -1) { return; }
            pos.ligne = aliens[mk].pos.ligne + dx[occupe_garde - 1];
            pos.colonne = aliens[mk].pos.colonne + dy[occupe_garde - 1];
            vector<position> prec1;
            cout << occupe_garde << " " << dist_garde << endl;
            cout << pos.ligne << " " << pos.colonne << endl;
            cout << dist[pos] << endl;
            while (pos != agent[garde]) {
                prec1.push_back(pos);
                pos = prec[pos];
            }
            int points = 8, lg = (int) prec1.size() - 1;
            while (points > 0 && lg >= 0) {
                position nv = prec1[lg];
                if (pos.ligne == nv.ligne && pos.colonne > nv.colonne) { /// OUEST
                    if (pos.colonne == nv.colonne + 1) { deplacer(garde, OUEST); points--; }
                    else if (points >= 3) { glisser(garde, OUEST); points -= 3; }
                    else { points = 0; }
                }
                else if (pos.ligne == nv.ligne && pos.colonne < nv.colonne) { /// EST
                    if (pos.colonne == nv.colonne - 1) { deplacer(garde, EST); points--; }
                    else if (points >= 3) { glisser(garde, EST); points -= 3; }
                    else { points = 0; }
                }
                else if (pos.ligne > nv.ligne && pos.colonne == nv.colonne) { /// NORD
                    if (pos.ligne == nv.ligne + 1) { deplacer(garde, NORD); points--; }
                    else if (points >= 3) { glisser(garde, NORD); points -= 3; }
                    else { points = 0; }
                }
                else { /// SUD
                    if (pos.ligne == nv.ligne - 1) { deplacer(garde, SUD); points--; }
                    else if (points >= 3) { glisser(garde, SUD); points -= 3; }
                    else { points = 0; }
                }
                pos = nv;
                lg--;
            }
            if (points >= 5) {
                if (occupe_garde == 1) {
                    pousser(garde, NORD);
                    deplacer(garde, NORD);
                }
                else if (occupe_garde == 2) {
                    pousser(garde, OUEST);
                    deplacer(garde, OUEST);
                }
                else if (occupe_garde == 3) {
                    pousser(garde, EST);
                    deplacer(garde, EST);
                }
                else {
                    pousser(garde, SUD);
                    deplacer(garde, SUD);
                }
            }
        }
        else if (agent_sur_case(pos) == id_joueur) {
            cout << "joueur" << endl;
            position nvx = pos;
            int place = 0;
            while (carte[nvx.ligne][nvx.colonne] == LIBRE) {
                nvx.colonne++;
            }
            if (agent_sur_case(nvx) == id_adv && place == 0) {
                pos.colonne++;
                place = 1;
                dd(agent[garde]);
                if (dist[pos] == 1000) { return; }
                vector<position> prec1;
                while (pos != agent[garde]) {
                    prec1.push_back(pos);
                    pos = prec[pos];
                }
                int points = 8, lg = (int) prec1.size() - 1;
                while (points > 0 && lg >= 0) {
                    position nv = prec1[lg];
                    if (pos.ligne == nv.ligne && pos.colonne > nv.colonne) { /// OUEST
                        if (pos.colonne == nv.colonne + 1) { deplacer(garde, OUEST); points--; }
                        else if (points >= 3) { glisser(garde, OUEST); points -= 3; }
                        else { points = 0; }
                    }
                    else if (pos.ligne == nv.ligne && pos.colonne < nv.colonne) { /// EST
                        if (pos.colonne == nv.colonne - 1) { deplacer(garde, EST); points--; }
                        else if (points >= 3) { glisser(garde, EST); points -= 3; }
                        else { points = 0; }
                    }
                    else if (pos.ligne > nv.ligne && pos.colonne == nv.colonne) { /// NORD
                        if (pos.ligne == nv.ligne + 1) { deplacer(garde, NORD); points--; }
                        else if (points >= 3) { glisser(garde, NORD); points -= 3; }
                        else { points = 0; }
                    }
                    else { /// SUD
                        if (pos.ligne == nv.ligne - 1) { deplacer(garde, SUD); points--; }
                        else if (points >= 3) { glisser(garde, SUD); points -= 3; }
                        else { points = 0; }
                    }
                    pos = nv;
                    lg--;
                }
            }

            nvx = pos;
            while (carte[nvx.ligne][nvx.colonne] == LIBRE) {
                nvx.colonne--;
            }
            if (agent_sur_case(nvx) == id_adv && place == 0) {
                pos.colonne--;
                place = 1;
                dd(agent[garde]);
                if (dist[pos] == 1000) { return; }
                vector<position> prec1;
                while (pos != agent[garde]) {
                    prec1.push_back(pos);
                    pos = prec[pos];
                }
                int points = 8, lg = (int) prec1.size() - 1;
                while (points > 0 && lg >= 0) {
                    position nv = prec1[lg];
                    if (pos.ligne == nv.ligne && pos.colonne > nv.colonne) { /// OUEST
                        if (pos.colonne == nv.colonne + 1) { deplacer(garde, OUEST); points--; }
                        else if (points >= 3) { glisser(garde, OUEST); points -= 3; }
                        else { points = 0; }
                    }
                    else if (pos.ligne == nv.ligne && pos.colonne < nv.colonne) { /// EST
                        if (pos.colonne == nv.colonne - 1) { deplacer(garde, EST); points--; }
                        else if (points >= 3) { glisser(garde, EST); points -= 3; }
                        else { points = 0; }
                    }
                    else if (pos.ligne > nv.ligne && pos.colonne == nv.colonne) { /// NORD
                        if (pos.ligne == nv.ligne + 1) { deplacer(garde, NORD); points--; }
                        else if (points >= 3) { glisser(garde, NORD); points -= 3; }
                        else { points = 0; }
                    }
                    else { /// SUD
                        if (pos.ligne == nv.ligne - 1) { deplacer(garde, SUD); points--; }
                        else if (points >= 3) { glisser(garde, SUD); points -= 3; }
                        else { points = 0; }
                    }
                    pos = nv;
                    lg--;
                }
            }

            nvx = pos;
            while (carte[nvx.ligne][nvx.colonne] == LIBRE) {
                nvx.ligne++;
            }
            if (agent_sur_case(nvx) == id_adv && place == 0) {
                pos.ligne++;
                place = 1;
                dd(agent[garde]);
                if (dist[pos] == 1000) { return; }
                vector<position> prec1;
                while (pos != agent[garde]) {
                    prec1.push_back(pos);
                    pos = prec[pos];
                }
                int points = 8, lg = (int) prec1.size() - 1;
                while (points > 0 && lg >= 0) {
                    position nv = prec1[lg];
                    if (pos.ligne == nv.ligne && pos.colonne > nv.colonne) { /// OUEST
                        if (pos.colonne == nv.colonne + 1) { deplacer(garde, OUEST); points--; }
                        else if (points >= 3) { glisser(garde, OUEST); points -= 3; }
                        else { points = 0; }
                    }
                    else if (pos.ligne == nv.ligne && pos.colonne < nv.colonne) { /// EST
                        if (pos.colonne == nv.colonne - 1) { deplacer(garde, EST); points--; }
                        else if (points >= 3) { glisser(garde, EST); points -= 3; }
                        else { points = 0; }
                    }
                    else if (pos.ligne > nv.ligne && pos.colonne == nv.colonne) { /// NORD
                        if (pos.ligne == nv.ligne + 1) { deplacer(garde, NORD); points--; }
                        else if (points >= 3) { glisser(garde, NORD); points -= 3; }
                        else { points = 0; }
                    }
                    else { /// SUD
                        if (pos.ligne == nv.ligne - 1) { deplacer(garde, SUD); points--; }
                        else if (points >= 3) { glisser(garde, SUD); points -= 3; }
                        else { points = 0; }
                    }
                    pos = nv;
                    lg--;
                }
            }

            if (place == 0) {
                pos.ligne--;
                place = 1;
                dd(agent[garde]);
                if (dist[pos] == 1000) { return; }
                vector<position> prec1;
                while (pos != agent[garde]) {
                    prec1.push_back(pos);
                    pos = prec[pos];
                }
                int points = 8, lg = (int) prec1.size() - 1;
                while (points > 0 && lg >= 0) {
                    position nv = prec1[lg];
                    if (pos.ligne == nv.ligne && pos.colonne > nv.colonne) { /// OUEST
                        if (pos.colonne == nv.colonne + 1) { deplacer(garde, OUEST); points--; }
                        else if (points >= 3) { glisser(garde, OUEST); points -= 3; }
                        else { points = 0; }
                    }
                    else if (pos.ligne == nv.ligne && pos.colonne < nv.colonne) { /// EST
                        if (pos.colonne == nv.colonne - 1) { deplacer(garde, EST); points--; }
                        else if (points >= 3) { glisser(garde, EST); points -= 3; }
                        else { points = 0; }
                    }
                    else if (pos.ligne > nv.ligne && pos.colonne == nv.colonne) { /// NORD
                        if (pos.ligne == nv.ligne + 1) { deplacer(garde, NORD); points--; }
                        else if (points >= 3) { glisser(garde, NORD); points -= 3; }
                        else { points = 0; }
                    }
                    else { /// SUD
                        if (pos.ligne == nv.ligne - 1) { deplacer(garde, SUD); points--; }
                        else if (points >= 3) { glisser(garde, SUD); points -= 3; }
                        else { points = 0; }
                    }
                    pos = nv;
                    lg--;
                }
            }
        }
        else {
            cout << "rien" << endl;
            dd(agent[garde]);
            if (dist[pos] == 1000) { return; }
            vector<position> prec1;
            while (pos != agent[garde]) {
                prec1.push_back(pos);
                pos = prec[pos];
            }
            int points = 8, lg = (int) prec1.size() - 1;
            while (points > 0 && lg >= 0) {
                position nv = prec1[lg];
                if (pos.ligne == nv.ligne && pos.colonne > nv.colonne) { /// OUEST
                    if (pos.colonne == nv.colonne + 1) { deplacer(garde, OUEST); points--; }
                    else if (points >= 3) { glisser(garde, OUEST); points -= 3; }
                    else { points = 0; }
                }
                else if (pos.ligne == nv.ligne && pos.colonne < nv.colonne) { /// EST
                    if (pos.colonne == nv.colonne - 1) { deplacer(garde, EST); points--; }
                    else if (points >= 3) { glisser(garde, EST); points -= 3; }
                    else { points = 0; }
                }
                else if (pos.ligne > nv.ligne && pos.colonne == nv.colonne) { /// NORD
                    if (pos.ligne == nv.ligne + 1) { deplacer(garde, NORD); points--; }
                    else if (points >= 3) { glisser(garde, NORD); points -= 3; }
                    else { points = 0; }
                }
                else { /// SUD
                    if (pos.ligne == nv.ligne - 1) { deplacer(garde, SUD); points--; }
                    else if (points >= 3) { glisser(garde, SUD); points -= 3; }
                    else { points = 0; }
                }
                pos = nv;
                lg--;
            }
        }
    }
    for (int i = 0; i < NB_AGENTS; i++) {
        carte[agent_adv[i].ligne][agent_adv[i].colonne] = LIBRE;
    }
    /// RESTE A FAIRE
    /// soutien quand agent libre
    /// quand on n'a pas l'avantage : utiliser un gars en soutien pour reprendre la main
    /// privilegier les grosses recompenses
    /// sauf quand plus de 30% de murs (a discuter)
    /*vector<pair<alien_info, int>> dist_alien;
    position perturber = agent_adv[0];
    for (int i = 0; i < NB_AGENTS; i++) {
        if (info_alien(agent_adv[i]).capture_en_cours >= 0) { perturber = agent_adv[i]; break; }
    }
    int kp = -1;
    vector<direction> cible_chemin;
    for (int k = 0; k < 4; k++) {
        position approche = perturber;
        approche.colonne += dy[k];
        approche.ligne += dx[k];
        cible_chemin = chemin(agent[3], approche);
        if (agent[3] == approche || cible_chemin.size() > 0) {
            for (int i = 0; i < min(8, (int) cible_chemin.size()); i++) {
                deplacer(3,cible_chemin[i]);
            }
            kp = k;
            break;
        }
    }
    if (cible_chemin.size() <= 3) {
        cout << id_joueur << " " << kp << endl;
        erreur e;
        if (kp == 0) { e = pousser(3,NORD); }
        if (kp == 1) { e = pousser(3,OUEST); }
        if (kp == 2) { e = pousser(3,EST); }
        if (kp == 3) { e = pousser(3,SUD); }
        cout << e << endl;
    } else { cout << " " << cible_chemin.size() << endl;}
    for (int i = 0; i < nb_aliens; i++) {
        dist_alien.push_back(make_pair(aliens[i], abs(aliens[i].pos.ligne - agent[0].ligne)+abs(aliens[i].pos.colonne - agent[0].colonne)));
    }
    sort(dist_alien.begin(), dist_alien.end(), cmp_alien);
    for (int i = 0; i < nb_aliens; i++) {
        aliens[i] = dist_alien[i].first;
    }
    if (0 && (info_alien(agent[0]).duree_invasion == -1 || info_alien(agent[0]).capture_en_cours == NB_TOURS_CAPTURE)) {
        alien_info cible;
        cible.capture_en_cours = -1;
        vector<direction> cible_chemin;
        for (int i = 0; i < nb_aliens; i++) {
            cible_chemin = chemin(agent[0], aliens[i].pos);
            if (agent[0] == aliens[i].pos && aliens[i].capture_en_cours < NB_TOURS_CAPTURE) {
                cible = aliens[i];
                break;
            }
            if (cible_chemin.size() > 0 && tour >= aliens[i].tour_invasion && tour < (aliens[i].duree_invasion + aliens[i].tour_invasion - 3) && aliens[i].capture_en_cours < NB_TOURS_CAPTURE) {
                cible = aliens[i];
                break;
            }
        }
        if (cible.capture_en_cours == -1) { return; }
        for (int i = 0; i < min(8, (int) cible_chemin.size()); i++) {
            deplacer(0,cible_chemin[i]);
        }
        int trouve = 1;
        for (int k = 0; k < 4; k++) {
            alien_info garde = cible;
            garde.pos.colonne += dy[k];
            garde.pos.ligne += dx[k];
            cible_chemin = chemin(agent[trouve], garde.pos);
            if (agent[trouve] == garde.pos || cible_chemin.size() > 0) {
                for (int i = 0; i < min(8, (int) cible_chemin.size()); i++) {
                    deplacer(trouve,cible_chemin[i]);
                }
                trouve++;
                if (trouve == 3) { break; }
            }
        }
    }
    */
}

/// Fonction appelée à la fin de la partie.
void partie_fin()
{
  // fonction a completer
}
