/// This file has been generated, if you wish to
/// modify it in a permanent way, please refer
/// to the script file : gen/generator_cxx.rb

#include "prologin.hh"
#include <bits/stdc++.h>

using namespace std;

/// STRATEGIE GENERALE
///
/// dans le cas general on regarde quels sont les 4 aliens tels que la somme des distances soit minimisee
/// si un alien est accessible mais l'ennemi est deja dessus, on cherche a s'en approcher a distance 1 pour le pousser
/// les plus courts chemins sont calcules a l'aide de l'algorithme de Dijkstra
/// j'ai cherche a privilegier les aliens qui rapportent plus, mais je ne suis pas arrive a tirer avantage de cette donnee
/// aussi, je voulais faire en sorte que s'il y avait moins d'aliens que d'agents, lse agents libres viennent soutenir ceux en activite,
/// mais j'obtenais la aussi des resultats moins bons donc je l'ai enleve du code

/// CAS PARTICULIERS
///
/// le cas ou tous les aliens donnent un nombre nul ou negatif de points est gere a part, je m'assure que tout le monde
/// bouge a chaque tour si possible, pour ne capturer aucun alien
///
/// le cas ou la carte est vide avec des aliens partout est approximativement traite, mais par manque de temps je n'ai pas pu faire
/// quelque chose de vraiment parfait

int id_joueur, id_adv, nb_aliens, attaque, max_points = 1, min_points = pow(2,30);
int dx[] = {1,0,0,-1};
int dy[] = {0,1,-1,0};
vector<alien_info> aliens;
case_type carte[TAILLE_BANQUISE][TAILLE_BANQUISE];
map<position, vector<pair<int, position>>> graphe;
position agent[NB_AGENTS], agent_adv[NB_AGENTS];
map<position, int> dist;
map<position, position> prec;
int vide = 0;

bool cmp_alien(pair<alien_info, int> a, pair<alien_info, int> b) {
    return a.second < b.second;
}

void dd(position s) { /// algorithme de Dijkstra
    position pos;
    for (int i = 0; i < TAILLE_BANQUISE; i++) {
        pos.ligne = i;
        for (int j = 0; j < TAILLE_BANQUISE; j++) {
            pos.colonne = j;
            dist[pos] = 1000;
        }
    }
    priority_queue<pair<int, pair<position,position>>> q;
    q.push(make_pair(0,make_pair(s,s)));
    while (!q.empty()) {
        pair<int, pair<position,position>> t = q.top();
        q.pop();
        if (dist[t.second.second] > -t.first) {
            dist[t.second.second] = -t.first;
            prec[t.second.second] = t.second.first;
            for (int i = 0; i < (int) graphe[t.second.second].size(); i++) {
                q.push(make_pair(-dist[t.second.second] - graphe[t.second.second][i].first, make_pair(t.second.second, graphe[t.second.second][i].second)));
            }
        }
    }
}

/// Fonction appelée au début de la partie.
void partie_init()
{
    id_joueur = moi();
    id_adv = adversaire();
    position pos;
    /// on recupere la carte de la banquise
    for (int i = 0; i < TAILLE_BANQUISE; i++) {
        pos.ligne = i;
        for (int j = 0; j < TAILLE_BANQUISE; j++) {
            pos.colonne = j;
            carte[i][j] = type_case(pos);
            if (carte[i][j] == LIBRE) { vide++; }
        }
    }
    /// on regarde s'il y a des aliens a score strictement positif ou pas
    aliens = liste_aliens();
    nb_aliens = (int) aliens.size();
    max_points = aliens[0].points_capture;
    min_points = aliens[0].points_capture;
    for (int i = 1; i < nb_aliens; i++) {
        max_points = max(max_points, aliens[i].points_capture);
        min_points = min(min_points, aliens[i].points_capture);
    }
}

/// Fonction appelée à chaque tour.
void jouer_tour()
{
    int tour = tour_actuel();
    position pos,pos2;
    /// on reinitialise le graphe de la banquise
    for (int i = 0; i < TAILLE_BANQUISE; i++) {
        pos.ligne = i;
        for (int j = 0; j < TAILLE_BANQUISE; j++) {
            pos.colonne = j;
            graphe[pos].clear();
        }
    }
    /// positions des agents
    /// on considere les agents ennemis comme des murs
    for (int i = 0; i < NB_AGENTS; i++) {
        agent[i] = position_agent(id_joueur, i);
        agent_adv[i] = position_agent(id_adv, i);
        carte[agent_adv[i].ligne][agent_adv[i].colonne] = MUR;
    }
    /// on repertorie les mouvements possibles
    for (int i = 0; i < TAILLE_BANQUISE; i++) {
        pos2.ligne = i;
        for (int j = 0; j < TAILLE_BANQUISE; j++) {
            pos2.colonne = j;
            for (int k = 0; k < 4; k++) {
                pos.ligne = i + dx[k];
                pos.colonne = j + dy[k];
                if (i+dx[k] < 0 || i+dx[k] > 24 || j+dy[k] < 0 || j+dy[k] > 24) { continue; }
                if (carte[i][j] == LIBRE && carte[pos.ligne][pos.colonne] == LIBRE) { graphe[pos2].push_back(make_pair(1, pos)); }
            }
        }
    }
    /// on repertorie les glissades horizontales possibles
    for (int i = 0; i < TAILLE_BANQUISE; i++) {
        int j = 0;
        pos.ligne = i;
        pos2.ligne = i;
        while (j < 25) {
            while (j < 25 && carte[i][j] == MUR) { j++; }
            pos.colonne = j;
            if (j == 25) { break; }
            while (j < 25 && carte[i][j] == LIBRE) {
                pos2.colonne = j;
                if (j-pos.colonne >= 3) {
                    graphe[pos2].push_back(make_pair(3, pos));
                }
                j++;
            }
            j--;
            pos2.colonne = j;
            if (j-pos.colonne >= 3) {
                graphe[pos].push_back(make_pair(3, pos2));
            }
            j++;
        }
    }
    /// on repertorie les glissades verticales possibles
    for (int i = 0; i < TAILLE_BANQUISE; i++) {
        int j = 0;
        pos.colonne = i;
        pos2.colonne = i;
        while (j < 25) {
            while (j < 25 && carte[j][i] == MUR) { j++; }
            pos.ligne = j;
            if (j == 25) { break; }
            while (j < 25 && carte[j][i] == LIBRE) {
                pos2.ligne = j;
                if (j-pos.ligne >= 3) {
                    graphe[pos2].push_back(make_pair(3, pos));
                }
                j++;
            }
            j--;
            if (j-pos.ligne >= 3) {
                graphe[pos].push_back(make_pair(3, pos2));
            }
            j++;
        }
    }
    aliens = liste_aliens();
    nb_aliens = (int) aliens.size();
    vector<int> dist_agents[4];
    vector<int> occupe_aliens[4];
    /// cas ou tous les aliens enlevent des points
    if (max_points <= 0) {
        for (int i = 0; i < 4; i++) {
            for (int k = 0; k < NB_AGENTS; k++) {
                for (int l = 0; l < 4; l++) {
                    pos.ligne = agent[k].ligne + dx[l];
                    pos.colonne = agent[k].colonne + dy[l];
                    if (pos.ligne < 0 || pos.ligne > 24 || pos.colonne < 0 || pos.colonne > 24) { continue; }
                    if (carte[pos.ligne][pos.colonne] == LIBRE) {
                        if (l == 0) { deplacer(k, SUD); }
                        else if (l == 1) { deplacer(k, EST); }
                        else if (l == 2) { deplacer(k, OUEST); }
                        else { deplacer(k, NORD); }
                        break;
                    }
                }
            }
        }
        return;
    }
    /// carte maximisation
    if (agent[0].ligne < 10 && min_points == max_points && vide == TAILLE_BANQUISE * TAILLE_BANQUISE) {
        if (tour == 0) {
            for (int k = 0; k < 4; k++) {
                deplacer(k, SUD);
                deplacer(k, SUD);
                deplacer(k, SUD);
                deplacer(k, SUD);
                deplacer(k, SUD);
                deplacer(k, SUD);
                deplacer(k, SUD);
            }
        }
        if (tour == 45 && tour % 3 == 0) {
            for (int k = 0; k < 4; k++) {
                deplacer(k, SUD);
                deplacer(k, SUD);
                deplacer(k, SUD);
                deplacer(k, SUD);
            }
        }
        else if (tour > 45 && tour % 3 == 0) {
            deplacer(0, OUEST);
            deplacer(1, OUEST);
            deplacer(2, OUEST);
            deplacer(3, OUEST);
        }
        else if (tour < 45 && tour % 3 == 0) {
            deplacer(0, EST);
            deplacer(1, EST);
            deplacer(2, EST);
            deplacer(3, EST);
        }
        return;
    }
    /// idem
    else if (min_points == max_points && vide == TAILLE_BANQUISE * TAILLE_BANQUISE) {
        if (tour == 0) {
            for (int k = 0; k < 4; k++) {
                deplacer(k, NORD);
                deplacer(k, NORD);
                deplacer(k, NORD);
                deplacer(k, NORD);
                deplacer(k, NORD);
                deplacer(k, NORD);
                deplacer(k, NORD);
            }
        }
        if (tour == 45 && tour % 3 == 0) {
            for (int k = 0; k < 4; k++) {
                deplacer(k, NORD);
                deplacer(k, NORD);
                deplacer(k, NORD);
                deplacer(k, NORD);
            }
        }
        else if (tour > 45 && tour % 3 == 0) {
            deplacer(0, EST);
            deplacer(1, EST);
            deplacer(2, EST);
            deplacer(3, EST);
        }
        else if (tour < 45 && tour % 3 == 0) {
            deplacer(0, OUEST);
            deplacer(1, OUEST);
            deplacer(2, OUEST);
            deplacer(3, OUEST);
        }
        return;
    }
    /// on liste la distance entre chaque alien et chaque agent
    for (int k = 0; k < 4; k++) {
        dd(agent[k]);
        for (int i = 0; i < nb_aliens; i++) {
            if (aliens[i].points_capture > 0 && tour+min(2, dist[aliens[i].pos]) >= aliens[i].tour_invasion && tour+3-aliens[i].capture_en_cours <= (aliens[i].tour_invasion + aliens[i].duree_invasion) && aliens[i].capture_en_cours < NB_TOURS_CAPTURE) {
                dist_agents[k].push_back(dist[aliens[i].pos]);
                occupe_aliens[k].push_back(0);
                if (dist[aliens[i].pos] == 1000) { /// si l'alien n'est pas accessible on regarde si on peut s'en approcher a distance 1
                    for (int l = 0; l < 4; l++) {
                        pos.ligne = aliens[i].pos.ligne + dx[l];
                        pos.colonne = aliens[i].pos.colonne + dy[l];
                        if (pos.ligne < 0 || pos.ligne > 24 || pos.colonne < 0 || pos.colonne > 24) { continue; }
                        if (dist[pos] < dist_agents[k][i] && carte[pos.ligne - 2*dx[l]][pos.colonne - 2*dy[l]] == LIBRE) {
                            occupe_aliens[k][i] = l+1;
                            dist_agents[k][i] = dist[pos];
                        }
                    }
                }
            }
            else { dist_agents[k].push_back(1000); occupe_aliens[k].push_back(0); }
        }
    }
    /// on cible les 4 aliens (ou moins) les plus proches
    int mk1, mk2, mk3, mk4;
    int min_dist = 9001;
    for (int k1 = 0; k1 < nb_aliens; k1++) {
        for (int k2 = 0; k2 < nb_aliens; k2++) {
            if (k1 == k2) { continue; }
            for (int k3 = 0; k3 < nb_aliens; k3++) {
                if (k3 == k2) { continue; }
                if (k1 == k3) { continue; }
                for (int k4 = 0; k4 < nb_aliens; k4++) {
                    if (k4 == k1) { continue; }
                    if (k4 == k2) { continue; }
                    if (k4 == k3) { continue; }
                    int sm = dist_agents[0][k1]+dist_agents[1][k2]+dist_agents[2][k3]+dist_agents[3][k4];
                    if (sm < min_dist) {
                        min_dist = sm;
                        mk1 = k1; mk2 = k2; mk3 = k3; mk4 = k4;
                    }
                }
            }
        }
    }
    /// mouvement des agents
    for (int k = 0; k < 4; k++) {
        int dst, occupe, mk;
        vector<position> prec1; /// chemin a suivre
        if (k == 0) { mk = mk1; }
        else if (k == 1) { mk = mk2; }
        else if (k == 2) { mk = mk3; }
        else { mk = mk4; }
        pos = aliens[mk].pos;
        dst = dist_agents[k][mk];
        occupe = occupe_aliens[k][mk];
        /// si on est a cote d'un alien avec un ennemi au-dessus
        if (dst == 0 && occupe > 0) {
            if (occupe == 1) {
                pousser(k, NORD);
                deplacer(k, NORD);
            }
            else if (occupe == 2) {
                pousser(k, OUEST);
                deplacer(k, OUEST);
            }
            else if (occupe == 3) {
                pousser(k, EST);
                deplacer(k, EST);
            }
            else {
                pousser(k, SUD);
                deplacer(k, SUD);
            }
        }
        /// sinon si on a bien une cible
        else if (dst < 1000) {
            if (occupe > 0) {
                pos.ligne += dx[occupe-1];
                pos.colonne += dy[occupe-1];
            }
            dd(agent[k]);
            while (pos != agent[k]) {
                prec1.push_back(pos);
                pos = prec[pos];
            }
            int points = 8, lg = (int) prec1.size() - 1;
            while (points > 0 && lg >= 0) {
                position nv = prec1[lg];
                if (pos.ligne == nv.ligne && pos.colonne > nv.colonne) { /// OUEST
                    if (pos.colonne == nv.colonne + 1) { deplacer(k, OUEST); points--; }
                    else if (points >= 3) { glisser(k, OUEST); points -= 3; }
                    else { points = 0; }
                }
                else if (pos.ligne == nv.ligne && pos.colonne < nv.colonne) { /// EST
                    if (pos.colonne == nv.colonne - 1) { deplacer(k, EST); points--; }
                    else if (points >= 3) { glisser(k, EST); points -= 3; }
                    else { points = 0; }
                }
                else if (pos.ligne > nv.ligne && pos.colonne == nv.colonne) { /// NORD
                    if (pos.ligne == nv.ligne + 1) { deplacer(k, NORD); points--; }
                    else if (points >= 3) { glisser(k, NORD); points -= 3; }
                    else { points = 0; }
                }
                else { /// SUD
                    if (pos.ligne == nv.ligne - 1) { deplacer(k, SUD); points--; }
                    else if (points >= 3) { glisser(k, SUD); points -= 3; }
                    else { points = 0; }
                }
                pos = nv;
                lg--;
            }
            if (points >= 5 && occupe > 0) {
                if (occupe == 1) {
                    pousser(k, NORD);
                    deplacer(k, NORD);
                }
                else if (occupe == 2) {
                    pousser(k, OUEST);
                    deplacer(k, OUEST);
                }
                else if (occupe == 3) {
                    pousser(k, EST);
                    deplacer(k, EST);
                }
                else {
                    pousser(k, SUD);
                    deplacer(k, SUD);
                }
            }
            if (points >= 5) {
                for (int l = 0; l < 4; l++) {
                    pos2.ligne = pos.ligne + dx[l];
                    pos2.colonne = pos.colonne + dy[l];
                    if (pos2.ligne < 0 || pos2.ligne > 24 || pos2.colonne < 0 || pos2.colonne > 24) { continue; }
                    if (agent_sur_case(pos2) == id_adv) {
                        if (l == 0) { pousser(k, NORD); }
                        else if (l == 1) { pousser(k, OUEST); }
                        else if (l == 2) { pousser(k, EST); }
                        else { pousser(k, SUD); }
                        points -= 5;
                        break;
                    }
                }
            }
        }
    }
    /// les agents ennemis ne sont plus consideres comme des murs
    for (int i = 0; i < NB_AGENTS; i++) {
        carte[agent_adv[i].ligne][agent_adv[i].colonne] = LIBRE;
    }
}

/// Fonction appelée à la fin de la partie.
void partie_fin()
{
  // fonction a completer
}
